diff --git a/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java b/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java
index 468a8d6f1..00f25b96a 100644
--- a/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java
+++ b/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java
@@ -19,7 +19,7 @@ public class GuiConnectToIP extends GuiScreen
     @Override
 	public void tick()
     {
-        field_22111_h.updateCursorCounter();
+        textField.updateCursorCounter();
     }
 
     @Override
@@ -32,9 +32,9 @@ public class GuiConnectToIP extends GuiScreen
         controlList.add(new GuiButton(1, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.connect_to_ip.button.cancel")));
         String s = mc.gameSettings.lastServer.value.replaceAll("_", ":");
         controlList.get(0).enabled = s.length() > 0;
-        field_22111_h = new GuiTextField(this, fontRenderer, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, s, "");
-        field_22111_h.isFocused = true;
-        field_22111_h.setMaxStringLength(128);
+        textField = new GuiTextField(this, fontRenderer, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, s, "");
+        textField.isFocused = true;
+        textField.setMaxStringLength(128);
     }
 
     @Override
@@ -56,7 +56,7 @@ public class GuiConnectToIP extends GuiScreen
         } else
         if(button.id == 0)
         {
-            String serverUrl = field_22111_h.getText().trim();
+            String serverUrl = textField.getText().trim();
             mc.gameSettings.lastServer.value = serverUrl.replaceAll(":", "_");
             mc.gameSettings.saveOptions();
             ServerAddress address = ServerAddress.resolveServerIP(serverUrl);
@@ -68,19 +68,19 @@ public class GuiConnectToIP extends GuiScreen
 	public void keyTyped(char c, int i, int mouseX, int mouseY)
     {
         if(i != Keyboard.KEY_BACK) super.keyTyped(c, i, mouseX, mouseY);
-        field_22111_h.textboxKeyTyped(c, i);
+        textField.textboxKeyTyped(c, i);
         if(c == '\r')
         {
             buttonPressed((GuiButton)controlList.get(0));
         }
-        ((GuiButton)controlList.get(0)).enabled = field_22111_h.getText().length() > 0;
+        ((GuiButton)controlList.get(0)).enabled = textField.getText().length() > 0;
     }
 
     @Override
 	public void mouseClicked(int mouseX, int mouseY, int mouseButton)
     {
         super.mouseClicked(mouseX, mouseY, mouseButton);
-        field_22111_h.mouseClicked(mouseX, mouseY, mouseButton);
+        textField.mouseClicked(mouseX, mouseY, mouseButton);
     }
 
     @Override
@@ -90,9 +90,9 @@ public class GuiConnectToIP extends GuiScreen
         drawDefaultBackground();
         drawStringCentered(fontRenderer, i18n.translateKey("gui.connect_to_ip.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
         drawString(fontRenderer, i18n.translateKey("gui.connect_to_ip.label.enter_ip"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xa0a0a0);
-        field_22111_h.drawTextBox();
+        textField.drawTextBox();
         super.drawScreen(mouseX, mouseY, partialTick);
     }
 
-    private GuiTextField field_22111_h;
+    private GuiTextField textField;
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiConnecting.java b/src/main/java/net/minecraft/client/gui/GuiConnecting.java
index dc5458ebc..1a5263144 100644
--- a/src/main/java/net/minecraft/client/gui/GuiConnecting.java
+++ b/src/main/java/net/minecraft/client/gui/GuiConnecting.java
@@ -1,23 +1,68 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.net.handler.NetClientHandler;
+import net.minecraft.client.net.handler.ClientPacketHandler;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.client.net.thread.ThreadConnectToServer;
+import net.minecraft.core.net.packet.PreLoginPacket;
+
+import java.net.ConnectException;
+import java.net.UnknownHostException;
 
 // Referenced classes of package net.minecraft.src:
-//            GuiScreen, ThreadConnectToServer, NetClientHandler, StringTranslate, 
+//            GuiScreen, ThreadConnectToServer, ClientPacketHandler, StringTranslate,
 //            GuiButton, GuiMainMenu
 
 public class GuiConnecting extends GuiScreen
 {
 
-    public GuiConnecting(Minecraft minecraft, String s, int i)
+    public GuiConnecting(Minecraft minecraft, String hostName, int port)
     {
         cancelled = false;
-        System.out.println("Connecting to " + s + ", " + i);
+        System.out.println("Connecting to " + hostName + ", " + port);
         minecraft.changeWorld(null);
-        (new ThreadConnectToServer(this, minecraft, s, i)).start();
+        new Thread(() -> {
+            try
+            {
+                clientHandler = new ClientPacketHandler(mc, hostName, port);
+                if(cancelled)
+                {
+                    return;
+                }
+                clientHandler.addToSendQueue(new PreLoginPacket(mc.session.username));
+            }
+            catch(UnknownHostException unknownhostexception)
+            {
+                if(cancelled)
+                {
+                    return;
+                }
+                mc.displayGuiScreen(new GuiConnectFailed("connect.failed", "disconnect.genericReason", new Object[] {
+                    "Unknown host '" + hostName + "'"
+                }));
+            }
+            catch(ConnectException connectexception)
+            {
+                if(cancelled)
+                {
+                    return;
+                }
+                mc.displayGuiScreen(new GuiConnectFailed("connect.failed", "disconnect.genericReason", new Object[] {
+                    connectexception.getMessage()
+                }));
+            }
+            catch(Exception exception)
+            {
+                if(cancelled)
+                {
+                    return;
+                }
+                exception.printStackTrace();
+                mc.displayGuiScreen(new GuiConnectFailed("connect.failed", "disconnect.genericReason", new Object[] {
+                    exception.toString()
+                }));
+            }
+
+        }).start();
     }
 
     @Override
@@ -25,7 +70,7 @@ public class GuiConnecting extends GuiScreen
     {
         if(clientHandler != null)
         {
-            clientHandler.processReadPackets();
+            clientHandler.tick();
         }
     }
 
@@ -68,26 +113,11 @@ public class GuiConnecting extends GuiScreen
         } else
         {
             drawStringCentered(fontRenderer, stringtranslate.translateKey("gui.connecting.label.logging_in"), width / 2, height / 2 - 50, 0xffffff);
-            drawStringCentered(fontRenderer, clientHandler.field_1209_a, width / 2, height / 2 - 10, 0xffffff);
+            drawStringCentered(fontRenderer, clientHandler.message, width / 2, height / 2 - 10, 0xffffff);
         }
         super.drawScreen(mouseX, mouseY, partialTick);
     }
 
-    public static NetClientHandler setNetClientHandler(GuiConnecting guiconnecting, NetClientHandler netclienthandler)
-    {
-        return guiconnecting.clientHandler = netclienthandler;
-    }
-
-    public static boolean isCancelled(GuiConnecting guiconnecting)
-    {
-        return guiconnecting.cancelled;
-    }
-
-    public static NetClientHandler getNetClientHandler(GuiConnecting guiconnecting)
-    {
-        return guiconnecting.clientHandler;
-    }
-
-    private NetClientHandler clientHandler;
+    private ClientPacketHandler clientHandler;
     private boolean cancelled;
 }
